Amazon SDE-I Intern Interview Experience | September 2026 | On Campus

amazon logo
amazon
· SDE-I Intern
October 1, 2026 · 3 reads

Summary

I cleared the online assessment but was rejected after the technical round because I could not solve the DP problem.

Full Experience

Firstly, we had an Online Assesment (OA) on Hackerrank with the following format:

  • 1 DSA Question

Minimum Total Cost to Make Array Non-Decreasing

You are given an integer array nums of length n.

In one operation, you choose a contiguous segment nums[l..r] (where 0 <= l <= r < n) and a positive integer x, then add x to every element in that segment. The cost of the operation is x.

You may perform any number of operations. Return the minimum total cost needed to make nums non-decreasing (nums[i] <= nums[i+1] for all 0 <= i < n - 1).

Example 1
Input: nums = [3,1,2,4]
Output: 2
Explanation: Choose the segment [1..2] and add x = 2:
[3,1,2,4] -> [3,3,4,4]
Total cost = 2. It can't be done for less.

Example 2
Input: nums = [1,2,3]
Output: 0
Explanation: The array is already non-decreasing.

Example 3
Input: nums = [5,3,4,1]
Output: 5
Explanation: Add 2 to the segment [1..3] -> [5,5,6,3], then add 3 to the segment [3..3] -> [5,5,6,6].
Total cost = 2 + 3 = 5.

Constraints
1 <= n <= 10^5
1 <= nums[i] <= 10^9

  • 1 Coding repository question (you can choose between SpringBoot, Express, Django or C++ as your preferred language to work in), you'll be given access to an enterprise level structured codebase with a bunch of debugging tasks (6 to be precise) to complete within an hour.
  • You have an AI assistant but it can only help you in navigating the files and understanding basic syntax, if it feels like your query is about the approach itself, it will just provide a generic response of "I can't answer since it's within the territory of the answer", something alone these lines.
  • Work Style Assessment (DO NOT take this lightly, this is where Amazon Leadership Principles (LP) come into play)

Status: Cleared for interview, I solved the DSA question I got with all 15/15 test cases passed, and the work style assessment. I was not able to do well on the coding repository question.

The first technical round went in the following format for a duration of 1 hour:

  • Introduction
  • DP problem (https://leetcode.com/problems/tallest-billboard/)
  • Next Smaller Element (NSE)
  • Follow up on NSE, what would you change in your code if the array was circular?
  • LP: Tell me about your internship, have you faced deadlines before? If so, how did you handle them?
  • Final Q&A from my end

Status: Rejected, I was not able to solve the DP problem even after taking hints and spending nearly 30 minutes out of my 1 hour interview. I had not practised DP extensively and it stung the most during this interview. Coming up with the brute force could be difficult if you had not come across this type of problems before, and I certainly fell into this bracket.

What I learnt: Companies are still focusing on DSA, while at the same time, expanding the ways they are testing you via coding repository questions etc., For Amazon specifically, take the LP's seriously.

Interview Questions (3)

1.

Minimum Total Cost to Make Array Non-Decreasing

Data Structures & Algorithms

Given an integer array nums of length n, you can perform any number of operations. In each operation you choose a contiguous segment nums[l..r] (where 0 ≤ l ≤ r < n) and a positive integer x, then add x to every element in that segment. The cost of the operation is x. Return the minimum total cost needed to make nums non‑decreasing (i.e., nums[i] ≤ nums[i+1] for all 0 ≤ i < n‑1).

2.

Tallest Billboard

Data Structures & Algorithms

Given a set of rods with various lengths, partition them into two groups such that the sum of lengths in each group is equal and as large as possible. Return the maximum possible sum of one group (the height of the billboard). If it is impossible, return 0.

3.

Next Smaller Element (NSE) and Circular Variant

Data Structures & Algorithms

Given an array, for each element find the next smaller element to its right (Next Smaller Element). A follow‑up variation asks how the solution would change if the array were considered circular, i.e., after the last element you continue from the first.

📣 Found this helpful? Please share it with friends who are preparing for interviews!

Discussion (0)

Share your thoughts and ask questions

Join the Discussion

Sign in with Google to share your thoughts and ask questions

No comments yet

Be the first to share your thoughts and start the discussion!